# coding: utf-8

"""
    fine-tuning-api-server

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Any, List, Optional
from pydantic.v1 import BaseModel, Field, StrictStr, ValidationError, validator
from clients.fine_tuning.models.lora_tune_output import LoraTuneOutput
from clients.fine_tuning.models.null_tune import NullTune
from typing import Union, Any, List, TYPE_CHECKING
from pydantic.v1 import StrictStr, Field

DETAILS1_ONE_OF_SCHEMAS = ["LoraTuneOutput", "NullTune"]

class Details1(BaseModel):
    """
    Tune details.
    """
    # data type: LoraTuneOutput
    oneof_schema_1_validator: Optional[LoraTuneOutput] = None
    # data type: NullTune
    oneof_schema_2_validator: Optional[NullTune] = None
    if TYPE_CHECKING:
        actual_instance: Union[LoraTuneOutput, NullTune]
    else:
        actual_instance: Any
    one_of_schemas: List[str] = Field(DETAILS1_ONE_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    discriminator_value_class_map = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = Details1.construct()
        error_messages = []
        match = 0
        # validate data type: LoraTuneOutput
        if not isinstance(v, LoraTuneOutput):
            error_messages.append(f"Error! Input type `{type(v)}` is not `LoraTuneOutput`")
        else:
            match += 1
        # validate data type: NullTune
        if not isinstance(v, NullTune):
            error_messages.append(f"Error! Input type `{type(v)}` is not `NullTune`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in Details1 with oneOf schemas: LoraTuneOutput, NullTune. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in Details1 with oneOf schemas: LoraTuneOutput, NullTune. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> Details1:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Details1:
        """Returns the object represented by the json string"""
        instance = Details1.construct()
        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("tune_type")
        if not _data_type:
            raise ValueError("Failed to lookup data type from the field `tune_type` in the input.")

        # check if data type is `LoraTuneOutput`
        if _data_type == "LoraTune-Output":
            instance.actual_instance = LoraTuneOutput.from_json(json_str)
            return instance

        # check if data type is `NullTune`
        if _data_type == "NullTune":
            instance.actual_instance = NullTune.from_json(json_str)
            return instance

        # check if data type is `LoraTuneOutput`
        if _data_type == "lora_tune":
            instance.actual_instance = LoraTuneOutput.from_json(json_str)
            return instance

        # check if data type is `NullTune`
        if _data_type == "null":
            instance.actual_instance = NullTune.from_json(json_str)
            return instance

        # deserialize data into LoraTuneOutput
        try:
            instance.actual_instance = LoraTuneOutput.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into NullTune
        try:
            instance.actual_instance = NullTune.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into Details1 with oneOf schemas: LoraTuneOutput, NullTune. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into Details1 with oneOf schemas: LoraTuneOutput, NullTune. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        to_dict = getattr(self.actual_instance, "to_dict", None)
        if callable(to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())


